

#ifndef NULL
  #define  NULL    ((void *)0)
#endif


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// classes `SArrayD': Type-secure interfaces to `SArray'.              //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

template<class T>
class SArray_ : public SArray {
public :

  // Data

  SArray_(const int rank, int* rngs) : SArray(rank, rngs, sizeof(T)) {}

  // Coercion

  SArray_(Array parent) : SArray(parent) {}

  T* els() {return (T*) dat() ; }
} ;


template<class T>
class SArray0 : public SArray_<T> {
public :

  // Data

  SArray0() : SArray_<T>(0, (int*) NULL) {}

  // Coercion

  SArray0(Array parent) : SArray_<T>(parent) {}

  T& operator()() {
    return els() [0] ;
  }
} ;


template<class T>
class SArray1 : public SArray_<T> {
public :

  // Data

  SArray1(int n_1) : SArray_<T>(1, seq(n_1)) {}

  // Coercion

  SArray1(Array parent) : SArray_<T>(parent) {}

  T& operator()(int i_1) {
    return els() [str(0) * i_1] ;
  }
} ;


template<class T>
class SArray2 : public SArray_<T> {
public :

  // Data

  SArray2(int n_1, int n_2) : SArray_<T>(2, seq(n_1, n_2)) {}

  // Coercion

  SArray2(Array parent) : SArray_<T>(parent) {}

  T& operator()(int i_1, int i_2) {
    return els() [str(0) * i_1 + str(1) * i_2] ;
  }
} ;


template<class T>
class SArray3 : public SArray_<T> {
public :

  // Data

  SArray3(int n_1, int n_2, int n_3) :
      SArray_<T>(3, seq(n_1, n_2, n_3)) {}

  // Coercion

  SArray3(Array parent) : SArray_<T>(parent) {}

  T& operator()(int i_1, int i_2, int i_3) {
    return els() [str(0) * i_1 + str(1) * i_2 + str(2) * i_3] ;
  }
} ;


