
// Miscellaneous common operations on ranges.

#include <stdlib.h>
#include <stdio.h>
#include "globals.h"
#include "Procs.h"
#include "Range.h"

#ifdef NO_STATIC_CONSTRUCTORS

void RangeInit() {
  // Initialise memory pools.

  CollapsedRangeRep :: pool       = new Pool(sizeof(CollapsedRangeRep))       ;
  CollapsedSubRangeRep :: pool    = new Pool(sizeof(CollapsedSubRangeRep))    ;
  BlockRangeRep :: pool           = new Pool(sizeof(BlockRangeRep))           ;
  BlockSubRangeRep :: pool        = new Pool(sizeof(BlockSubRangeRep))        ;
  CyclicRangeRep :: pool          = new Pool(sizeof(CyclicRangeRep))          ;
  CyclicSubRangeRep :: pool       = new Pool(sizeof(CyclicSubRangeRep))       ;
  BlockCyclicRangeRep :: pool     = new Pool(sizeof(BlockCyclicRangeRep))     ;
  BlockCyclicSubRangeRep :: pool  = new Pool(sizeof(BlockCyclicSubRangeRep))  ;
  StepRangeRep :: pool            = new Pool(sizeof(StepRangeRep))            ;
  StepSubRangeRep :: pool         = new Pool(sizeof(StepSubRangeRep))         ;
  RangeRep :: pool                = new Pool(sizeof(RangeRep))                ;

  SimpleStrideRep :: pool         = new Pool(sizeof(SimpleStrideRep))         ;
  MultiblockStrideRep :: pool     = new Pool(sizeof(MultiblockStrideRep))     ;
  PackedStrideRep :: pool         = new Pool(sizeof(PackedStrideRep))         ;
  PackedMultiblockStrideRep :: pool =
                                  new Pool(sizeof(PackedMultiblockStrideRep)) ;
  PromoteStrideRep :: pool        = new Pool(sizeof(PromoteStrideRep))        ;
}

void RangeFinalize() {
  delete CollapsedRangeRep :: pool       ;
  delete CollapsedSubRangeRep :: pool    ;
  delete BlockRangeRep :: pool           ;
  delete BlockSubRangeRep :: pool        ;
  delete CyclicRangeRep :: pool          ;
  delete CyclicSubRangeRep :: pool       ;
  delete BlockCyclicRangeRep :: pool     ;
  delete BlockCyclicSubRangeRep :: pool  ;
  delete StepRangeRep :: pool            ;
  delete StepSubRangeRep :: pool         ;
  delete RangeRep :: pool                ;

  delete SimpleStrideRep :: pool         ;
  delete MultiblockStrideRep :: pool     ;
  delete PackedStrideRep :: pool         ;
  delete PackedMultiblockStrideRep :: pool ;
  delete PromoteStrideRep :: pool        ;
}

#endif

// ---------------------------------------------------
//
// Things to do:
//

