
#include "stdio.h"

#include "ad++.h"
#include "admacros.h"

void read_image(char* filename, Array2<int> image,
                int* nx, int *ny, int *maxin) {

// _____________________________________________________________________
//|                                                                     |
//| Subroutine, to read in a .pgm format image from file, into an       |
//| integer array.                                                      |
//|                                                                     |
//| H W Yau.  14th of February, 1994.                                   |
//| Northeast Parallel Architectures Center.                            |
//| Syracuse University.                                                |
//|_____________________________________________________________________|
//|                                                                     |
//| Edit record:                                                        |
//| 14/Feb/1995: Copied from Guy and Ken's wavelet code.  Hon-ie-fied.  |
//|_____________________________________________________________________|

// .. Local variables ..

  Range i = image.rng(0), j = image.rng(1) ;
  char magic [2] ;

// Read simple image from a file.

  FILE* ifile = gfopen(filename, "r") ;

  gfscanf(ifile, "%2s%d%d%d", magic, nx, ny, maxin) ;
  gprintf("Reading image %s of size %6d by %6d pixels Max intensity =%6d\n",
          filename, *nx, *ny, *maxin) ;

  Array s = image.sect(i.subrng(*nx, 0), j.subrng(*ny, 0)) ;
  afscanf(ifile, "%d", &s) ;

  gfclose(ifile) ;
}

