
#include "stdio.h"

#include "ad++.h"
#include "admacros.h"

void write_image(char* filename, Array2<int> image,
                 int nx, int ny, int maxin) {

// _____________________________________________________________________
//|                                                                     |
//| Subroutine, to write a .pgm format file, from an integer array.     |
//|                                                                     |
//| H W Yau.  14th of February, 1994.                                   |
//| Northeast Parallel Architectures Center.                            |
//| Syracuse University.                                                |
//|_____________________________________________________________________|
//|                                                                     |
//| Edit record:                                                        |
//| 14/Feb/1995: Copied from Guy and Ken's wavelet code.  Hon-ie-fied.  |
//|_____________________________________________________________________|

// .. Local variables ..

  Range i = image.rng(0), j = image.rng(1) ;

// Write out image into file.

  gprintf("Writing image %s of size %6d by %6d pixels Max intensity = %6d\n",
          filename, nx, ny, maxin) ;

  FILE* ifile = gfopen(filename, "w") ;

  gfprintf(ifile, "P2\n%d %d\n%d\n", nx, ny, maxin) ;

  Array s = image.sect(i.subrng(nx, 0), j.subrng(ny, 0)) ;
  afprintf(ifile, "%4d%16N", &s) ;

  gfclose(ifile) ;
}

