
// Sequential arrays.

#include <stdio.h>
#include <memory.h>
#include "SFrame.h"


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `SSection': Representation of sequential array section.       //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

SSection :: SSection(const int _rank, const int _typeLen) :
                SFrame(_rank, _typeLen) {

  // Create a new array.

  rngs = new int [rank] ;
  strs = new int [rank] ;
}

//SSection :: SSection(char* _data, const int _rank, int* _rngs, int* _strs,
SSection :: SSection(void* _data, const int _rank, int* _rngs, int* _strs,
                     const int _typeLen) : SFrame(_rank, _typeLen) {
  data = _data ;
  rngs = new int [rank] ;
  strs = new int [rank] ;
  for(int i = 0 ; i < rank ; i++) {
    rngs [i] = _rngs [i] ;
    strs [i] = _strs [i] ;
  }
}

SSection :: ~SSection() {
  delete [] strs ;
  delete [] rngs ;
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `SData': Representation of a sequential array variable.       //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

SData :: SData(const int _rank, int* _rngs, const int _typeLen) :
               SSection(_rank, _typeLen) {

  // Create a new sequential array.

  int size = 1 ;
  for(int i = 0 ; i < rank ; i++) {
    const int n = _rngs [i] ;

    rngs [i] = n ;
    strs [i] = size ;
    size    *= n ;
  }

  data = new char [size * typeLen] ;
}

SData :: ~SData() {
  delete [] data ;
}


// ------------------------------------------------------------
// Things to do
//

