
// real a(32), b(200)
// !hpf$ distribute a (block) onto p
// !hpf$ distribute b (block (100)) onto p
// !hpf$ processors p (4)
// 
// do i=1,200
//   b(i) = i
// enddo
// do i=1,32
//   a(i) = 1000*i
// enddo
// 
// a (10:19) = b (100 : 190 : 10)
// 
// do i=1,32
//   print "(F12.2)", a(i)
// enddo
// 
// end


#include <stdio.h>
#include "ad++.h"
#include "admacros.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  Procs1 p(4) ;

  Range x(32, p.dim(0), BLK) ;
  Array1<float> a(x, p) ;

  Range y(200, p.dim(0), BLK) ;
  Array1<float> b(y, p) ;

  ON(p) {

    Index j(y) ;
    WHERE(j)
      b(j) = 1 + j ;
    EREWH(j) ;

    Index i(x) ;
    WHERE(i)
      a(i) = 1000 * (1 + i) ;
    EREWH(i) ;

    Range xs = x.subrng(10, 9) ;
    Range ys = y.subrng(10, 99, 10) ;

    remap(a.sect(xs), b.sect(ys)) ;

  } NO(p) ;

  aprintf("%12.2f\n", a) ;

  } AdlibFinalize() ;
}


