

// Test all range variants.

#include <stdio.h>
#include <string.h>

#include "ad++.h"
#include "admacros.h"


const int n_cases = 30 ;

const int n = 50 ;

Range sample(char* desc, Dimension d, int i_case) {
  Range x ;

  switch(i_case) {
    case 0 :
      x = Range(n) ;
      strcpy(desc, "Range(n)") ;
      break ;
    case 1 :
      x = Range(n, d, BLK) ;
      strcpy(desc, "Range(n, d, BLK)") ;
      break ;
    case 2 :
      x = Range(n, d, CYC) ;
      strcpy(desc, "Range(n, d, CYC)") ;
      break ;
    case 3 :
      x = Range(n, d, STP) ;
      strcpy(desc, "Range(n, d, STP)") ;
      break ;
    case 4 :
      x = Range(n, d, BLK, 12) ;
      strcpy(desc, "Range(n, d, BLK, 12)") ;
      break ;
    case 5 :
      x = Range(n, d, CYC, 4) ;
      strcpy(desc, "Range(n, d, CYC, 4)") ;
      break ;
    case 6 :
      x = Range(400).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400).subrng(n, 100, 5)") ;
      break ;
    case 7 :
      x = Range(400, PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, PACKED).subrng(n, 100, 5)") ;
      break ;
    case 8 :
      x = Range(250).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250).subrng(n, 225, -4)") ;
      break ;
    case 9 :
      x = Range(250, PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, PACKED).subrng(n, 225, -4)") ;
      break ;
    case 10 :
      x = Range(400, d, BLK).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, BLK).subrng(n, 100, 5)") ;
      break ;
    case 11 :
      x = Range(400, d, BLK, PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, BLK, PACKED).subrng(n, 100, 5)") ;
      break ;
    case 12 :
      x = Range(250, d, BLK).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, BLK).subrng(n, 225, -4)") ;
      break ;
    case 13 :
      x = Range(250, d, BLK, PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, BLK, PACKED).subrng(n, 225, -4)") ;
      break ;
    case 14 :
      x = Range(400, d, CYC).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, CYC).subrng(n, 100, 5)") ;
      break ;
    case 15 :
      x = Range(400, d, CYC, ADAPT).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, CYC, ADAPT).subrng(n, 100, 5)") ;
      break ;
    case 16 :
      x = Range(250, d, CYC).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, CYC).subrng(n, 225, -4)") ;
      break ;
    case 17 :
      x = Range(250, d, CYC, ADAPT).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, CYC, ADAPT).subrng(n, 225, -4)") ;
      break ;
    case 18 :
      x = Range(400, d, STP).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, STP).subrng(n, 100, 5)") ;
      break ;
    case 19 :
      x = Range(400, d, STP, PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, STP, PACKED).subrng(n, 100, 5)") ;
      break ;
    case 20 :
      x = Range(250, d, STP).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, STP).subrng(n, 225, -4)") ;
      break ;
    case 21 :
      x = Range(250, d, STP, PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, STP, PACKED).subrng(n, 225, -4)") ;
      break ;
    case 22 :
      x = Range(400, d, BLK, 120).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, BLK, 120).subrng(n, 100, 5)") ;
      break ;
    case 23 :
      x = Range(250, d, BLK, 60).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, BLK, 60).subrng(n, 225, -4)") ;
      break ;
    case 24 :
      x = Range(400, d, CYC, 24).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, CYC, 24)(n, 100, 5)") ;
      break ;
    case 25 :
      x = Range(250, d, CYC, 17).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, CYC, 17).subrng(n, 225, -4)") ;
      break ;
    case 26 :
      x = Range(400, d, CYC, 24, PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, CYC, 24, PACKED).subrng(n, 100, 5)") ;
      break ;
    case 27 :
      x = Range(250, d, CYC, 17, PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, CYC, 17, PACKED).subrng(n, 225, -4)") ;
      break ;
    case 28 :
      x = Range(400, d, CYC, 24, ADAPT).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400, d, CYC, 24, ADAPT).subrng(n, 100, 5)") ;
      break ;
    case 29 :
      x = Range(250, d, CYC, 17, ADAPT).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250, d, CYC, 17, ADAPT).subrng(n, 225, -4)") ;
      break ;
  }
  return x ;
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  char xDesc [1024], yDesc [1024] ;

  Procs1 p(6) ;
  Dimension d = p.dim(0) ;

  for(int i = 0 ; i < n_cases ; i++) {
    Range x = sample(xDesc, d, i) ;
    for(int j = 0 ; j < n_cases ; j++) {
      Range y = sample(yDesc, d, j) ;

      gprintf("x = %s\n", xDesc) ;
      gprintf("y = %s\n", yDesc) ;

      Array1<float> a(x, p) ;
      Array1<float> b(y, p) ;
      Array1<int> mask1(y, p), mask2(y, p) ;

      ON(p) {
        Index i(x) ;
	WHERE(i) {
	  a(i) = i ;
	} EREWH(i) ;
      } NO(p) ;

      remap(b, a) ;

      ON(p) {
        Index i(y) ;
	WHERE(i) {
	  mask1(i) = b(i) == i ;
	  mask2(i) = b(i) != i ;
	} EREWH(i) ;
      } NO(p) ;

      if(!all(mask1) || any(mask2))
	    // Do both checks to reduce chance of bug in reductions.
        aprintf("%2R0%4d\n", b) ;
      else
	gprintf("Checked OK\n") ;

    //aprintf("%2R0%4d\n", b) ;
    }
  }

  } AdlibFinalize() ;
}


