#include <stdio.h>

#include "compilerApi.h"

#include "anls_att.h"

void Forall_index_def::setsymbol(SgSymbol * symb)
{
  indexvar=symb;
}

SgSymbol * Forall_index_def::getsymbol()
{
  return indexvar;
}

void Forall_index_def::setlb(SgSymbol * symb)
{
  lb=symb;
}

SgSymbol * Forall_index_def::getlb()
{
  return lb;
}
void Forall_index_def::setub(SgSymbol * symb)
{
  ub=symb;
}

SgSymbol * Forall_index_def::getub()
{
  return ub;
}
void Forall_index_def::setstep(SgSymbol * symb)
{
  step=symb;
}

SgSymbol * Forall_index_def::getstep()
{
  return step;
}

//--------------------------;

Forall_header_def::Forall_header_def(void)
{
  number=0;
  condition=NULL;
  for (int i=0; i<MAX_INDEX_DIM; i++) 
    for (int j=0; j<3; j++)
      index[i].indextriple[j]=NULL;
}

int Forall_header_def::getindexnumber(void)
{
  return number;
}

void Forall_header_def::setindexsymb(SgSymbol * s)
{
  number++;
  index[number-1].indexvar=s;
}

SgSymbol * Forall_header_def::getindexsymb(int i)
{
  return index[i].indexvar;
}

void Forall_header_def::setindextriple(int i, SgExpression * e)
{
  index[number-1].indextriple[i]=e;
}

SgExpression * Forall_header_def::getindextriple(int i, int j)
{
  return index[i].indextriple[j];
}

void Forall_header_def::setcondition(SgExpression * e)
{
  condition=e;
}

SgExpression * Forall_header_def::getcondition(void)
{
  return condition;
}

void Forall_header_def::show(void)
{
  for (int i=0; i<number; i++)
    printf("The %dth index is %s\n", i, index[i].indexvar->identifier());
}


int Forall_header_def::evaluatable_index(int i)
{
  if (i>=number)
    printf("No such index!");

  for (int j=0; j<3; j++) {
    if (index[i].indextriple[j]!=NULL)
      if (!index[i].indextriple[j]->isInteger())
	return(0);
  }  
  return (1);
}

// ------------------

forall_reference::forall_reference (Position s)
{
  side=s;

  for (int i=0; i<MAX_ALIGN_DIM; i++) 
    for (int j=0; j<MAX_INDEX_DIM; j++)
      index_level[i][j]=0;

  status = NONE;

}

int forall_reference::getposition()
{
  return side;
}

void forall_reference::setExpr(SgExpression * e)
{
  expr=e;
}

SgExpression * forall_reference::getexpression()
{
  return expr;
}

void forall_reference::setIndex(int arraydim, int indexdim,int IL)
{
  index_level[arraydim][indexdim]=IL;
}

int forall_reference::getIndex(int arraydim, int indexdim)
{
  return index_level[arraydim][indexdim];
}

void forall_reference::setstride(int arraydim, int indexdim, SgExpression * expr)
{
  stride[arraydim][indexdim]=expr;
}

SgExpression * forall_reference::getstride(int arraydim, int indexdim)
{
  return stride[arraydim][indexdim];
}

void forall_reference::setoffset(int arraydim, int indexdim, SgExpression * expr)
{
  offset[arraydim][indexdim]=expr;
}

SgExpression * forall_reference::getoffset(int arraydim, int indexdim)
{
  return offset[arraydim][indexdim];
}

void forall_reference::setCommunication(Communication com)
{
  status=com;
}

Communication forall_reference::getCommunication()
{
  return status;
}

int forall_reference::checkRegular()
{
  switch (expr->variant()) {
  case VAR_REF: 
    return (1);
    break;
  case ARRAY_REF:
    {
      SgArrayRefExp * array = (SgArrayRefExp *) expr;

      for (int i=0; i<array->numberOfSubscripts(); i++) {
	int indexcounter = 0;
	for (int j=0; j<MAX_INDEX_DIM; j++)
	  if (index_level[i][j]!=0)
	    if (index_level[i][j]!=1)
	      return 0;
	    else
	      indexcounter++;
	if (indexcounter>1)
	  return 0;
      }

      return 1;
      break;
    };
  default:
    printf("Not touched forall reference!\n");
  }
  return 0;
}

void forall_reference::setAmount(int i, int a)
{
  amount[i]=a;
}

int forall_reference::getAmount(int i)
{
  return amount[i];
}

int forall_reference::scalarDim(int dim)
{
// zheng.gb
  if (indexNumberOnDim(dim) == -1 ) return 1;
  return 0;
}

int forall_reference::tripletDim(int i)
{
// zheng.gb
/*
  if (expr->variant() != ARRAY_REF ) return 0;
  SgArrayType *type = (SgArrayType *)expr->symbol()->type();
  SgExpression *thedim = type->sizeInDim(i);
  return (thedim->lhs()->variant() == DDOT) ? 1:0;
*/
  return 1;
}

int forall_reference::hasScalarDim()
{
// zheng.gb
/*
  ASSERT (expr->variant() == ARRAY_REF) ;
  for (int i=0; i<((SgArrayRef*)expr)->numberOfSubscripts() ; i++)
  {
	
  }
*/
  return 0;
}

int forall_reference::indexNumberOnDim(int dim)
{
  for (int i=0; i<MAX_INDEX_DIM; i++)
    if (index_level[dim][i]!=0)
      return i;
  // return the first one;
  printf("indexNumberOnDim:This is a scalar dim.\n");
  return -1;
}

int forall_reference::evaluatable()
{
  for (int i=0; i<MAX_ALIGN_DIM; i++) {
    for (int j=0; j<MAX_INDEX_DIM; j++) {
      if (stride[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	};

      if (offset[i][j]!=NULL)
	if(!stride[i][j]->isInteger()) {
	  return(0);
	}
	  
    }
  }
  return (1);
}

void forall_reference::show()
{
  printf(" FR exp: % 3d is on %d side with index level: \n", expr->id(), int(side));
  for (int i=0; i< MAX_ALIGN_DIM; i++) {
    printf("      ");
    for (int j=0; j< MAX_INDEX_DIM; j++)
      printf("% 2d", index_level[i][j]);
    printf("\n");
  }

  printf("comm code :%d\n", status);

}












