#include <stdio.h>
#include <string.h>

#include "compilerApi.h"

#include "anls_att.h"

extern char * mixstring;
extern char * stackNameOfType(SgType *);
extern char * allocNameOfType(SgType *);
extern char * freeNameOfType(SgType *);

extern SgExpression * find_exp(int);
extern void tree_exp(SgExpression *, int);

void add_coef(SgStatement * s, int counter, int * amount)
{
  SgSymbol * coefsym = s->getSymbolInCurrentScope(mixstring, "coef", NULL);

  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
  forall_reference * fref=(forall_reference *)((s->childList1(0)->getAttribute(counter, Forall_Ref))->getAttributeData());

  //printf("The forall expression id is %d\n", fref->getexpression()->id());
  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb=fref->getexpression()->symbol(); 

  for (int i=0; i<array->numberOfSubscripts(); i++) {
    SgCallStmt * call = new SgCallStmt(*coefsym);

    {
      SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
      SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);
      call->addArg(*dadexp);
    };

    {
      SgValueExp * dimexp = new SgValueExp(i+1);
      call->addArg(*dimexp);
    }
    {
      int index=-1;
      for (int j=0; j<fhdef->getindexnumber(); j++)
	if (fref->getIndex(i, j)!=0) {
	  index=j;
	  break;
	};

      if (index==-1) {
	for (int j=0; j<3; j++) {
	  SgValueExp * dimexp = new SgValueExp(0);
	  call->addArg(*dimexp);
	}
      }
      else {
	for (int j=0; j<3; j++) {
	  if (fhdef->getindextriple(index, j)!=NULL) {
	    SgValueExp * strideExp = new SgValueExp(fhdef->getindextriple(index, j)->valueInteger());
	    call->addArg(*strideExp);
	  }
	  else {
	    SgValueExp * strideexp = new SgValueExp(1);
	    call->addArg(*strideexp);
 	  }
	}
      }
    }


    {
      int index=-1;
      for (int j=0; j<fhdef->getindexnumber(); j++)
	if (fref->getIndex(i, j)!=0) {
	  index=j;
	  break;
	};

      if (index==-1) {
	for (int j=0; j<2; j++) {
	  SgValueExp * dimexp = new SgValueExp(0);
	  call->addArg(*dimexp);
	}
      }
      else {
 	{
	  if (fref->getstride(i, index)!=NULL)
	    call->addArg(*fref->getstride(i, index));
	  else {
	    SgValueExp * strideexp = new SgValueExp(0);
	    call->addArg(*strideexp);	    
	  }
	}
	{
	  if (fref->getoffset(i, index)!=NULL)
	    call->addArg(*fref->getoffset(i, index));
	  else {
	    SgValueExp * strideexp = new SgValueExp(0);
	    call->addArg(*strideexp);	    
	  }
	}      
      }

    }

    {
      SgValueExp * amountexp = new SgValueExp(* (amount+i));
      call->addArg(*amountexp);
    }
    {
      SgSymbol * indexsym = s->getSymbolInCurrentScope(mixstring, "u", NULL, counter, i);
      SgExpression * indexexp = new SgExpression(VAR_REF, NULL, NULL, indexsym);
      call->addArg(*indexexp);
    }
    {
      SgSymbol * indexsym = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, i);
      SgExpression * indexexp = new SgExpression(VAR_REF, NULL, NULL, indexsym);
      call->addArg(*indexexp);
    }
    s->insertStmtBefore(*call, *s->controlParent());
  };
}

void change_scalar_reference(SgStatement * s, forall_reference * fref)
{
  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
  forall_reference * lfref = (forall_reference *) ((s->childList1(0)->getAttribute(0, Forall_Ref))->getAttributeData());

  SgExpression * oldscalar = fref->getexpression();
  SgSymbol * scalarsym = oldscalar->symbol();

  for (int i=0; i<fhdef->getindexnumber(); i++) {
    if(fhdef->getindexsymb(i)->id()==scalarsym->id()) {
      SgSymbol * lg=s->getSymbolInCurrentScope(mixstring, "glob", NULL);
      SgFunctionRefExp * lgfun = new SgFunctionRefExp(*lg);

      SgSymbol * rng=s->getSymbolInCurrentScope(mixstring, "irg", NULL, i);
      SgExpression * rngexp= new SgExpression(VAR_REF, NULL, NULL, rng);

      lgfun->addArg(*rngexp);

      // we need to get local index;

      SgExpression * indexexp= new SgExpression(VAR_REF, NULL, NULL, scalarsym);

      SgSymbol * indexs = s->getSymbolInCurrentScope(mixstring, "lis", scalarsym->identifier());
      SgExpression * indexsexp= new SgExpression(VAR_REF, NULL, NULL, indexs);

      (* indexexp)=(* indexsexp) * (* indexexp);

      SgSymbol * indexl = s->getSymbolInCurrentScope(mixstring, "lil", scalarsym->identifier());
      SgExpression * indexlexp= new SgExpression(VAR_REF, NULL, NULL, indexl);

      (* indexexp)=(* indexexp) + (* indexlexp);
      
      lgfun->addArg(*indexexp);

      oldscalar->replace(*lgfun);
     
      break;
    }
  }
}

// with flag==0, remain local, else change;

void change_array_reference(SgStatement * s, int counter, int nameflag, int indexflag)
{
  SgStatement * body = s->childList1(0);
  forall_reference * fref = (forall_reference *) ((body->getAttribute(counter, Forall_Ref))->getAttributeData());

  SgExpression * oldarray = fref->getexpression();
  SgSymbol * arraysym = oldarray->symbol();

  SgArrayRefExp * newarray;

  if (nameflag==0) {
    SgSymbol * local= s->getSymbolInCurrentScope(arraysym->identifier());
    newarray = new SgArrayRefExp(*local);
  }
  else {
    SgSymbol * rs= s->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysym->type()), NULL);
    newarray = new SgArrayRefExp(*rs);
  };

  SgSymbol * indexsym;

  if (indexflag==0)
    indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,counter); 
  else
    indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,0); 

  SgExpression * newindex = new SgExpression(VAR_REF, NULL, NULL, indexsym);

  if (indexflag==0) {
    if (nameflag==0)
      newarray->addSubscript(*newindex);
    else {
      SgSymbol * basesym = s->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);
      SgExpression * baseexp= new SgExpression(VAR_REF, NULL, NULL, basesym);
      (*newindex)=(*baseexp)+(*newindex);
      newarray->addSubscript(*newindex);
    }
  }
  else {
    SgSymbol * basesym = s->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);
    SgExpression * baseexp= new SgExpression(VAR_REF, NULL, NULL, basesym);
    (*newindex)=(*baseexp)+(*newindex);
    newarray->addSubscript(*newindex);
  };

  oldarray->replace(*newarray);
}

void append_index(SgStatement *s, int counter)
{
  SgStatement * body = s->childList1(0);
  forall_reference * fref = (forall_reference *) ((body->getAttribute(counter, Forall_Ref))->getAttributeData());
  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();

  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysym=fref->getexpression()->symbol();

  int dimcounter=0;

  SgExpression * firstexp= NULL;

  // first decide which dad used in str function;
    
  SgSymbol * dad;

  switch(fref->getCommunication()) {
  case IRREG:
    break;

  case UNKNOW:
    dad = s->getSymbolInCurrentScope(mixstring, "sdd", NULL, 0);
    break;

  case NONE:
    dad = s->getSymbolInCurrentScope(mixstring, "dad", fref->getexpression()->symbol()->identifier());
    break;

  case SHIFT:
    dad = s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);    
    break;

  case REMAP:
    dad = s->getSymbolInCurrentScope(mixstring, "sdd", NULL, 0);
    break;

  case BROADCAST:
    break;

  default:
    break;
  }

  //find the first dim and its index;

//   int firstdim=0;


//   for (int i=0; i<array->numberOfSubscripts(); i++) {
//     for (int index=0; index<fhdef->getindexnumber(); index++) {
//       if (fref->getIndex(i,index)!=0) {
// 	firstdim=i+1;
// 	dimcounter++;
// 	SgSymbol * vsymb = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, dimcounter-1);
// 	firstexp = new SgExpression(VAR_REF, NULL, NULL, vsymb);

// 	SgExpression * indexexp = new SgExpression (VAR_REF, NULL, NULL, fhdef->getindexsymb(index));

// 	SgSymbol * usymb = s->getSymbolInCurrentScope(mixstring, "u", NULL, counter, dimcounter-1);
// 	SgExpression * uexp = new SgExpression(VAR_REF, NULL, NULL, usymb);
// 	(*uexp)=(*uexp)*(*indexexp);
// 	(*firstexp)=(*uexp)+(*firstexp);
// 	break;
//       };
//     };

//     if (firstdim!=0)
//       break;
//   }


  SgExpression * rhs;

  rhs=firstexp;

  for (int i = 0; i<array->numberOfSubscripts(); i++) {
    for (int j=0; j<fhdef->getindexnumber(); j++) {
      if (fref->getIndex(i,j)!=0) {
	dimcounter++;

	SgExpression * indexexp = new SgExpression (VAR_REF, NULL, NULL, fhdef->getindexsymb(j));

	SgSymbol * vsymb = s->getSymbolInCurrentScope(mixstring, "v", NULL, counter, dimcounter-1);
	firstexp = new SgExpression(VAR_REF, NULL, NULL, vsymb);

	SgSymbol * usymb = s->getSymbolInCurrentScope(mixstring, "u", NULL, counter, dimcounter-1);

	SgExpression * uexp = new SgExpression(VAR_REF, NULL, NULL, usymb);

	(*uexp)=(*uexp)*(*indexexp);

	firstexp=firstexp+(*uexp);

	SgSymbol * strsym = s->getSymbolInCurrentScope(mixstring, "str", NULL);
	SgFunctionRefExp * strfun = new SgFunctionRefExp (*strsym);

	SgExpression * dadexp = new SgExpression (VAR_REF, NULL, NULL, dad);
	
	// dad is decide in the above;
	strfun->addArg(*dadexp);

	SgValueExp * dimexp= new SgValueExp(i+1);

	strfun->addArg(*dimexp);

	(rhs)=(rhs)+((*firstexp)*(*strfun));
      }
    };
  }    

  SgSymbol * indexsym = s->getSymbolInCurrentScope(mixstring, "sdx", NULL,counter); 
  SgExpression * indexexp = new SgExpression(VAR_REF, NULL, NULL, indexsym);

  SgAssignStmt * stmt = new SgAssignStmt( *indexexp, *rhs);

  // insert after the forall body;
  body->insertStmtAfter(*stmt, *s);

}

//flag == 0 means to create a array according to lhs;

void create_array (SgStatement *s, int flag, int counter)
{
  SgStatement * body;
  body = s->childList1(0);

  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();

  forall_reference * fref;

  if(flag==0)
    fref = (forall_reference *) ((body->getAttribute(0, Forall_Ref))->getAttributeData());
  else
    fref = (forall_reference *) ((body->getAttribute(counter, Forall_Ref))->getAttributeData());

  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();
  SgSymbol * arraysymb  = fref->getexpression()->symbol();

  {
    SgSymbol * symb;

    symb= s->getSymbolInCurrentScope(mixstring, "new_array_section", NULL);
    SgFunctionRefExp * funref = new SgFunctionRefExp(*symb);

    SgValueExp * dim = new SgValueExp(fhdef->getindexnumber());
    funref->addArg(*dim);

    SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);

    funref->addArg(*dadexp);

    symb=s->getSymbolInCurrentScope(mixstring, "tdd", NULL,counter);

    SgExpression * dadsecexp = new SgExpression (VAR_REF, NULL, NULL, symb);

    SgAssignStmt * assign = new SgAssignStmt ( *dadsecexp, *funref);

    s->insertStmtBefore(*assign, *s->controlParent());
  }

  int dimcounter = 0;

  for (int i=0; i<array->numberOfSubscripts(); i++) {
    int index = -1;
    for (int j = 0; j<fhdef->getindexnumber(); j++)
      if (fref->getIndex(i, j)!=0)
	index = j;

    if (index!=-1) {
      SgSymbol * symb= s->getSymbolInCurrentScope(mixstring, "set_array_triplet", NULL);
      SgCallStmt * funcall= new SgCallStmt(*symb);

      {
	SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
	SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);

	funcall->addArg(*dadsecexp);
      }
      {
	dimcounter++;
	SgValueExp * secdim = new SgValueExp (dimcounter);
	funcall->addArg(*secdim);
      }
    
      // the following subprogram add start, end, stride;

      {
	for (int j=0; j<2; j++) {
	  //SgExpression  * newsub = new  SgExpression (EXPR_LIST);
	  //(*newsub)=(*fref->getstride(i,index))*(*fhdef->getindextriple(index,j))+(*fref->getoffset(i,index));
	  SgExpression  * newsub = NULL;
	  newsub=newsub+(*fref->getoffset(i,index));
	  newsub=newsub+((*fref->getstride(i,index))*(*fhdef->getindextriple(index,j)));

	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
        };

	if (fhdef->getindextriple(index, 2)!=NULL) {
	  SgExpression  * newsub = new  SgExpression (EXPR_LIST);
	  (*newsub)=(*fref->getstride(i,index))*(*fhdef->getindextriple(index,2));
	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
	}
	else {
	  SgExpression  * newsub = fref->getstride(i,index);
	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
        }
      }
      {
	SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
	SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);

	funcall->addArg(*dadexp);
      }
      {
	SgValueExp * dim = new SgValueExp (i+1);
	funcall->addArg(*dim);
      }
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
    else {
      SgSymbol * symb= s->getSymbolInCurrentScope(mixstring, "set_array_scalar", NULL);
      SgCallStmt * funcall= new SgCallStmt(*symb);
      {
	SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
	SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);

	funcall->addArg(*dadsecexp);
      }
      {
	SgExpression * scalar = ( (SgArrayRefExp *) fref->getexpression() ) ->subscript(i);
	funcall->addArg(*scalar);
      }
      {
	SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
	SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);

	funcall->addArg(*dadexp);
      };
      {
	SgValueExp * dim = new SgValueExp (i+1);
	funcall->addArg(*dim);
      }
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
  }
  // allocate memory;
  {
    SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
    SgExpression * baseexp=new SgExpression(VAR_REF, NULL, NULL, base);

    SgSymbol * franame = s->getSymbolInCurrentScope(mixstring, allocNameOfType(arraysymb->type()), NULL);
    SgFunctionRefExp * rafuncexpr = new SgFunctionRefExp (*franame);

    SgSymbol * fsizename = s->getSymbolInCurrentScope(mixstring, "size", NULL);
    SgFunctionRefExp * sizefuncexpr = new SgFunctionRefExp (*fsizename);

    SgSymbol * dadbase = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * dadbaseexp=new SgExpression(VAR_REF, NULL, NULL, dadbase);
    sizefuncexpr->addArg(*dadbaseexp);

    rafuncexpr->addArg(*sizefuncexpr);

    SgStatement * alloc = new SgAssignStmt(*baseexp, *rafuncexpr);

    s->insertStmtBefore(*alloc, *s->controlParent());
  }
  // reset base;
  {
    SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "reset_array_base", NULL);
    SgCallStmt * funcall = new SgCallStmt (*symb);

    SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * baseexpr=new SgExpression(VAR_REF, NULL, NULL, base);
    funcall->addArg(*baseexpr);

    SgSymbol * rs= s->getSymbolInCurrentScope(mixstring, stackNameOfType(arraysymb->type()), NULL);
    SgArrayRefExp * stackarray = new SgArrayRefExp(*rs);

    SgSymbol * basesym = s->getSymbolInCurrentScope(mixstring, "tbs", NULL,counter);
    SgExpression * baseexp= new SgExpression(VAR_REF, NULL, NULL, basesym);

    stackarray->addSubscript(*baseexp);
    funcall->addArg(*stackarray);

    s->insertStmtBefore(*funcall, *s->controlParent());
  }
  // call delete_array;
  {
    SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "delete_array", NULL);
    SgCallStmt * funcall = new SgCallStmt (*symb);

    SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
    SgExpression * baseexpr=new SgExpression(VAR_REF, NULL, NULL, base);
    funcall->addArg(*baseexpr);
    
    s->insertStmtAfter(*funcall, *s->controlParent());
  }
  // call real free;
  {
    SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, freeNameOfType(arraysymb->type()), NULL);
    SgCallStmt * funcall = new SgCallStmt (*symb);
    
    SgSymbol * base = s->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
    SgExpression * baseexpr=new SgExpression(VAR_REF, NULL, NULL, base);
    
    funcall->addArg(*baseexpr);
    
    s->insertStmtAfter(*funcall, *s->controlParent());
  }
  
}


void delete_section(SgStatement *s, int counter)
{
  SgSymbol * symb;

  symb=s->getSymbolInCurrentScope(mixstring, "delete_array", NULL);

  SgCallStmt * funcall= new SgCallStmt(*symb);
  {
    SgSymbol * symb;

    symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
    SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, symb);

    funcall->addArg(*dadexp);
  };
  s->insertStmtAfter(*funcall, *s->controlParent());
}

// create section, but need not allocate memmory;

void create_section(SgStatement *s, int counter)
{

  SgStatement * body;
  body = s->childList1(0);

  Forall_header_def * fhdef = (Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();

  forall_reference * fref;
  fref = (forall_reference *) ((body->getAttribute(counter, Forall_Ref))->getAttributeData());

  SgArrayRefExp * array = (SgArrayRefExp *) fref->getexpression();  
  SgSymbol * arraysymb  = fref->getexpression()->symbol();

  {
    SgSymbol * symb;

    symb= s->getSymbolInCurrentScope(mixstring, "new_array_section", NULL);
    SgFunctionRefExp * funref = new SgFunctionRefExp(*symb);

    SgValueExp * dim = new SgValueExp(fhdef->getindexnumber());
    funref->addArg(*dim);

    SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
    SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);

    funref->addArg(*dadexp);

    symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);

    SgExpression * dadsecexp = new SgExpression (VAR_REF, NULL, NULL, symb);

    SgAssignStmt * assign = new SgAssignStmt ( *dadsecexp, *funref);

    s->insertStmtBefore(*assign, *s->controlParent());
  }

  int dimcounter = 0;

  for (int i=0; i<array->numberOfSubscripts(); i++) {
    int index = -1;
    for (int j = 0; j<fhdef->getindexnumber(); j++)
      if (fref->getIndex(i, j)!=0)
	index = j;

    if (index!=-1) {
      SgSymbol * symb= s->getSymbolInCurrentScope(mixstring, "set_array_triplet", NULL);
      SgCallStmt * funcall= new SgCallStmt(*symb);

      {
	SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
	SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);

	funcall->addArg(*dadsecexp);
      }
      {
	dimcounter++;
	SgValueExp * secdim = new SgValueExp (dimcounter);
	funcall->addArg(*secdim);
      }

      // the following subprogram add start, end, stride;
      
      {
	for (int j=0; j<2; j++) {
	  //SgExpression  * newsub = new  SgExpression (EXPR_LIST);
	  //(*newsub)=(*fref->getstride(i,index))*(*fhdef->getindextriple(index,j))+(*fref->getoffset(i,index));
	  SgExpression  * newsub = NULL;
	  newsub=newsub+(*fref->getoffset(i,index));
	  
	  newsub=newsub+((*fref->getstride(i,index))*(*fhdef->getindextriple(index,j)));

	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
        };

	if (fhdef->getindextriple(index, 2)!=NULL) {
	  SgExpression  * newsub = new  SgExpression (EXPR_LIST);
	  (*newsub)=(*fref->getstride(i,index))*(*fhdef->getindextriple(index,2));
	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
	}
	else {
	  SgExpression  * newsub = fref->getstride(i,index);
	  if(newsub->isInteger())
	    newsub = new SgValueExp (newsub->valueInteger());
	  funcall->addArg(*newsub);
        }
      }

      {
        SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());	
	SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);

	funcall->addArg(*dadexp);
      }
      {
	SgValueExp * dim = new SgValueExp (i+1);
	funcall->addArg(*dim);
      }
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
    else {
      SgSymbol * symb= s->getSymbolInCurrentScope(mixstring, "set_array_scalar", NULL);
      SgCallStmt * funcall= new SgCallStmt(*symb);
      {
	SgSymbol * symb = s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
	SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);

	funcall->addArg(*dadsecexp);
      }
      {
	SgExpression * scalar = ( (SgArrayRefExp *) fref->getexpression() ) ->subscript(i);
	funcall->addArg(*scalar);
      }
      {
        SgSymbol * dad = s->getSymbolInCurrentScope(mixstring, "dad", arraysymb->identifier());
	SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, dad);
	
	funcall->addArg(*dadexp);
      };
      {
	SgValueExp * dim = new SgValueExp (i+1);
	funcall->addArg(*dim);
      }
      s->insertStmtBefore(*funcall, *s->controlParent());
    }
  }
  
  delete_section(s, counter);

}

void add_remap(SgStatement * s, int counter)
{
  SgSymbol * symb;
  
  symb=s->getSymbolInCurrentScope(mixstring, "remap", NULL);
  
  SgCallStmt * funcall= new SgCallStmt(*symb);

  symb=s->getSymbolInCurrentScope(mixstring, "tdd", NULL, counter);
  SgExpression * dadexp = new SgExpression(VAR_REF, NULL, NULL, symb);
  funcall->addArg(*dadexp);

  symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL , counter);
  SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);
  funcall->addArg(*dadsecexp);

  s->insertStmtBefore(*funcall, *s->controlParent());
}

void add_shift(SgStatement * s, int counter, int dim, int amount)
{
  SgSymbol * symb;
  
  symb=s->getSymbolInCurrentScope(mixstring, "tshift", NULL);
  
  SgCallStmt * funcall= new SgCallStmt(*symb);

  symb=s->getSymbolInCurrentScope(mixstring, "real_stack", NULL);
  SgArrayRefExp * stackexp = new SgArrayRefExp(*symb);
  SgSymbol * base =s->getSymbolInCurrentScope(mixstring, "tbs", NULL, counter);
  SgExpression * baseexp = new SgExpression(VAR_REF, NULL, NULL, base);
  stackexp->addSubscript(*baseexp);
  funcall->addArg(*stackexp);

  symb=s->getSymbolInCurrentScope(mixstring, "sdd", NULL, counter);
  SgExpression * dadsecexp = new SgExpression(VAR_REF, NULL, NULL, symb);
  funcall->addArg(*dadsecexp);

  SgValueExp * dimexp = new SgValueExp (dim+1);
  funcall->addArg(*dimexp);

  SgValueExp * amountexp = new SgValueExp (amount);
  funcall->addArg(*amountexp);

  s->insertStmtBefore(*funcall, *s->controlParent());
}

void do_remap(SgStatement * s, int counter)
{
  create_section(s, counter);
  create_array(s, 0, counter);
  add_remap(s, counter);
}

void do_shift(SgStatement * s, int counter, int * amount)
{
  create_section(s, counter);
  create_array(s, 1, counter);
  for (int i=0; i<MAX_ALIGN_DIM; i++) {
    // i shoud be the numbered according to section;
    // in fact, it should be processor dimention;

    if (*(amount+i)!=0) 
      add_shift(s, counter, i, *(amount+i));
  };
}




