
#include 	<stdio.h>
#include        <stdlib.h>
#include 	<malloc.h>
#include	<string.h>

#include        "compilerApi.h"

#include	"basic_fun.h"
#include	"global_var.h"

char	*get_file_out(char *);
void	process_file(SgFile *file);
void	process_fun(SgStatement *);
void	process_stmt(SgStatement *,SgStatement *);
int array_to_forall(SgStatement *,SgStatement *);
int where_to_forall(SgStatement *,SgStatement *);

SgVariableSymb	*temp_index[8];
SgValueExp 	*base_step;//default step is 1
SgValueExp	*base_lbound;
SgValueExp	*default_lsub;//Fortran default low bound is 1
SgStatement     *current;//current statement to be transformed
int		index_g;//digit for forall index variable. 
int		index_var;//digit for temporary variable.

/* This function is used to cut the surfix, so there is a record as different pass performed */

char *newOutputFileName(char *inputFileName)
{	
  char	*out;
  int	nameLength = strlen(inputFileName);
  
  out=(char *)malloc((unsigned)(nameLength+5));

  while (inputFileName[nameLength-1]!='.') {
    nameLength --;
  }

  for ( int i = 0; i< nameLength; i++) {
    out[i]=inputFileName[i];
  }

  out[nameLength-1]='\0';

  out=strcat(out,"_2.dep");

  return(out);
}

char	*get_file_out(char *file_in)
{	char	*file_out;
	int	i=0;
	
	
	file_out=(char *)malloc((unsigned)(strlen(file_in)+5));
	while (file_in[i]!='.') 
	{	file_out[i]=file_in[i];
		i++;
	}
	file_out[i]='\0';
	file_out=strcat(file_out,"_t.dep");
	return(file_out);
	
}

int main(int argc, char **argv)
{

  	SgProject 	project("test", argc, argv);
 	SgFile	*file=NULL;

  	SgStatement	*hedr_stmt,*next_stmt,*end_stmt;
	int	i=0,numoffunc,numoffiles;
	char	*file_in,*file_out;

	numoffiles=project.numberOfFiles();
	for(i=0;i<numoffiles;i++)
	{
		base_lbound=new SgValueExp(0);
		base_step=new SgValueExp(1);
		default_lsub=new SgValueExp(1);//fortran default low bound is 1
		file=&(project.file(i));	
		file_in=file->filept->filename;
  		if (file->languageType()!=ForSrc)
		{	printf("%s is  not fortran program.\n",file_in); 
			continue;
		}
		file_out=newOutputFileName(file_in);
		process_file(file);
		file->saveDepFile(file_out);
		//save the transformation result (AST) to file result*.dep

	}
  	return 0;
}

void	process_file(SgFile *file)	
{	int	hedr_id=0;
	SgStatement	*hedr_stmt,*global_stmt;

	//numoffunc=file->numberOfFunctions();
	global_stmt=file->firstStatement();
	hedr_stmt=global_stmt->childList1(hedr_id++);
	while (hedr_stmt)
	{
		process_fun(hedr_stmt);
		hedr_stmt=global_stmt->childList1(hedr_id++);

	}
}

void	process_fun(SgStatement *hedr_stmt)
{
        SgStatement     *cur_stmt,*next_stmt;
        int     cur_id=0,variant;

	cur_stmt=hedr_stmt->childList1(cur_id++);
	init_temp_index(hedr_stmt);
	while (cur_stmt && (variant=cur_stmt->variant())!=CONTROL_END)
	{	
		next_stmt=cur_stmt->nextInChildList();
		if (variant==CONTAINS_STMT)
		{	//cur_stmt=hedr_stmt->childList1(cur_id++);
			cur_stmt=next_stmt;
			while(cur_stmt && cur_stmt->variant()!=CONTROL_END)
			{	
				next_stmt=cur_stmt->nextInChildList();
				process_fun(cur_stmt);
				cur_stmt=next_stmt;
			 }
			break; 
		}
		
		process_stmt(hedr_stmt,cur_stmt);
		//cur_stmt=hedr_stmt->childList1(cur_id++);
		cur_stmt=next_stmt;
	}
	return;

}

void 	process_stmt(SgStatement *hedr_stmt,SgStatement *cur_stmt)
{
	SgStatement	*temp_stmt;
	int	variant;
	int	i,numofchild;
	
	if (!cur_stmt) return;
        switch (variant=cur_stmt->variant())
        {
/*
        case    FOR_NODE:
		numofchild=cur_stmt->numberOfChildrenList1();
		for(i=0;i<numofchild;i++)
		{	temp_stmt=cur_stmt->childList1(i);
			process_stmt(hedr_stmt,temp_stmt);
		}
		numofchild=cur_stmt->numberOfChildrenList2();
		for(i=0;i<numofchild;i++)
		{	temp_stmt=cur_stmt->childList2(i);
			process_stmt(hedr_stmt,temp_stmt);
		}
                 break;
        case    DO_WHILE_NODE:
                break;
        case    FORALL_CONSTRUCT_STMT:
                break;
        case    WHERE_BLOCK_STMT:
                break;
*/
        case    ASSIGN_STAT:
              	array_to_forall(hedr_stmt,cur_stmt);
                break;
        case    WHERE_NODE:
                where_to_forall(hedr_stmt,cur_stmt);
                break;
/*
        case    FORALL_STMT:
                break;
*/
        default:
		numofchild=cur_stmt->numberOfChildrenList1();
		for(i=0;i<numofchild;i++)
		{	temp_stmt=cur_stmt->childList1(i);
			process_stmt(hedr_stmt,temp_stmt);
		}
		numofchild=cur_stmt->numberOfChildrenList2();
		for(i=0;i<numofchild;i++)
		{	temp_stmt=cur_stmt->childList2(i);
			process_stmt(hedr_stmt,temp_stmt);
		}
                 break;
        }
	return;
}

