/* 
   This function binds generated parameters to the level 1 template.
*/

extern void binding_1(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,
        ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2) 
   int requirement, p,lx,ly,ux,uy,l,u,s,d1,d2;
   int ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2; {

   char* dc1= (char*) malloc(7); 
   char* dc2= (char*) malloc(7);

   printf("\n! ***** This is level 1 program *****\n");
   switch (requirement) {
      case 1:
         printf("\n! This program should require no communication \n\n");
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         break;
      case 2:
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         printf("\n! This program requires shift communication \n\n");
         break;
      case 3:
         if (d1==1) dc1 = "BLOCK"; else dc1 = "CYCLIC"; 
         if (d2==1) dc2 = "BLOCK"; else dc2 = "CYCLIC"; 
         printf("\n! This program requires remap communication \n\n");
         break;
      case 4:
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         printf("\n! This program requires both shift and remap \n\n");
         break;
      default:
         printf("No such a case \n");
         return;
   }
   printf("      PROGRAM MAIN \n");
   printf("      REAL X(%d:%d), Y(%d:%d) \n",lx,ux,ly,uy);
   printf("!HPF$ PROCESSORS P(%d) \n",p);
   printf("!HPF$ TEMPLATE TX(%d:%d),TY(%d:%d) \n",ltx,utx,lty,uty);
   printf("!HPF$ DISTRIBUTE TX(%s) ONTO P \n",dc1);
   printf("!HPF$ DISTRIBUTE TY(%s) ONTO P \n",dc2);
   if (bx >= 0)
      printf("!HPF$ ALIGN X(i) WITH TX(%d*i+%d) \n",ax,bx);
   else
      printf("!HPF$ ALIGN X(i) WITH TX(%d*i%d) \n",ax,bx);
   if (by >= 0)
      printf("!HPF$ ALIGN Y(i) WITH TY(%d*i+%d) \n\n",ay,by);
   else
      printf("!HPF$ ALIGN Y(i) WITH TY(%d*i%d) \n\n",ay,by);
   printf("      FORALL (i=%d:%d) X(i) = 0 \n", lx,ux);
   printf("      FORALL (i=%d:%d) Y(i) = i \n",ly,uy);
   if (b1 >=0 && b2>=0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i+%d) + Y(%d*i+%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else if (b1 >=0 && b2 <0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i+%d) + Y(%d*i%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else if (b1 < 0 && b2 >= 0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i%d) + Y(%d*i+%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i%i) + Y(%d*i%i) \n\n",
                           l,u,s,a1,b1,a2,b2);
   printf("      PRINT *, (X(i),i=%d,%d) \n",lx,ux);      
   printf("      END \n");
   return;
}

/* 
   This function binds generated parameters to the level 2 template.
*/

extern void binding_2(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,
        ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2,
        xs1l, xs1u, xs1s, ys1l, ys1u, ys1s,
        xs2l, xs2u, xs2s, ys2l, ys2u, ys2s) 
   int requirement, p,lx,ly,ux,uy,l,u,s,d1,d2;
   int ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2; 
   int xs1l,xs1u,xs1s,ys1l,ys1u,ys1s,xs2l,xs2u,xs2s,ys2l,ys2u,ys2s; {
   char* dc1 = (char *) malloc(7); 
   char* dc2 = (char *) malloc(7);

   printf("\n! ***** This is level 2 program *****\n");
   switch (requirement) {
      case 1:
         printf("\n! This program should require no communication \n\n");
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         break;
      case 2:
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         printf("\n! This program requires shift communication \n\n");
         break;
      case 3:
         if (d1==1) dc1 = "BLOCK"; else dc1 = "CYCLIC"; 
         if (d2==1) dc2 = "BLOCK"; else dc2 = "CYCLIC"; 
         printf("\n! This program requires remap communication \n\n");
         break;
      case 4:
         if (d1==1) dc1 = dc2 = "BLOCK"; else dc1 = dc2 = "CYCLIC"; 
         printf("\n! This program requires both shift and remap \n\n");
         break;
      default:
         printf("No such a case \n");
         return;
   }
   printf("      PROGRAM MAIN \n");
   printf("      REAL X(%d:%d), Y(%d:%d) \n", lx,ux,ly,uy);
   printf("!HPF$ PROCESSORS P(%d) \n",p);
   printf("!HPF$ TEMPLATE TX(%d:%d),TY(%d:%d) \n",ltx,utx,lty,uty);
   printf("!HPF$ DISTRIBUTE TX(%s) ONTO P \n",dc1);
   printf("!HPF$ DISTRIBUTE TY(%s) ONTO P \n",dc2);
   if (bx >= 0)
      printf("!HPF$ ALIGN X(i) WITH TX(%d*i+%d) \n",ax,bx);
   else
      printf("!HPF$ ALIGN X(i) WITH TX(%d*i%d) \n",ax,bx);
   if (by >= 0)
      printf("!HPF$ ALIGN Y(i) WITH TY(%d*i+%d) \n\n",ay,by);
   else
      printf("!HPF$ ALIGN Y(i) WITH TY(%d*i%d) \n",ay,by);
/*
   printf("
      INTERFACE
         SUBROUTINE FOO(X,Y) 
         REAL X(:),Y(:)
!HPF$    INHERIT X, Y
         END SUBROUTINE FOO
      END INTERFACE \n");
*/
   printf("      FORALL (i=%d:%d) X(i) = 0 \n",lx,ux);
   printf("      FORALL (i=%d:%d) Y(i) = i \n",ly,uy);
   if (b1 >=0 && b2>=0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i+%d) + Y(%d*i+%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else if (b1 >=0 && b2 <0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i+%d) + Y(%d*i%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else if (b1 < 0 && b2 >= 0 )
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i%d) + Y(%d*i+%d) \n\n",
                           l,u,s,a1,b1,a2,b2);
   else
      printf("      FORALL (i=%d:%d:%d) X(i) = Y(%d*i%i) + Y(%d*i%i) \n\n",
                           l,u,s,a1,b1,a2,b2);
   printf("      CALL FOO(X(%d:%d:%d),Y(%d:%d:%d)) \n",
                            xs1l,xs1u,xs1s,ys1l,ys1u,ys1s);
   printf("      CALL FOO(X(%d:%d:%d),Y(%d:%d:%d)) \n\n",
                            xs2l,xs2u,xs2s,ys2l,ys2u,ys2s);

   printf("      PRINT *, (X(i),i=%d,%d) \n",lx,ux);      
   printf("      END \n\n");

   printf("      SUBROUTINE FOO(X,Y) \n");
   printf("      REAL X(:), Y(:) \n"); 
   printf("!HPF$ INHERIT X,Y \n");
   printf("      FORALL (i=1:%d) X(i)=X(i)-Y(i)-Y(i+1) \n",
                 min((ys1u-ys1l)/ys1s+1,(xs1u-xs1l)/xs1s+1)-1);
   printf("      END \n");
   return;
};

/* 
   This function binds generated parameters to the level 3 template.
*/

extern void binding_3(requirement,lx1,ux1,lx2,ux2,ly1,uy1,ly2,uy2,p,ltx1,utx1,
        ltx2,utx2,lty1,uty1,lty2,uty2,d,ax1,bx1,ax2,bx2,ay1, by1,ay2,by2,l1,u1,
        s1,l2,u2,s2,lxs1,uxs1,sxs1,lxs2,uxs2,sxs2,slx, sux,sly,suy,sl,su) 
   int requirement,lx1,ux1,lx2,ux2, ly1,uy1,ly2,uy2;
   int p,ltx1,utx1,ltx2,utx2, lty1,uty1,lty2,uty2;
   int d[5];
   int ax1,bx1,ax2,bx2,ay1,by1,ay2,by2;
   int l1,u1,s1,l2,u2,s2;
   int lxs1,uxs1,sxs1,lxs2,uxs2,sxs2;
   int slx,sux,sly,suy,sl,su;                   {

   char* dc[5];
   int i;

   for (i=0;i<5;i++) dc[i] = (char *) malloc(7); 

   for (i=0;i<5;i++) 
      switch (d[i]) {
         case 1: dc[i] = "BLOCK";
                 break;
         case 2: dc[i] = "CYCLIC";
                 break;
         case 3: dc[i] = "*";
                 break;
         default:
            printf ("Illegal distribution \n");
            return;
      }

   printf("\n! ***** This is level 3 program *****\n");
   switch (requirement) {
      case 1:
         printf("\n! This program require (1,1), (2,2) communication \n\n");
         break;
      case 2:
         printf("\n! This program requires (1,2), (2,1) communication \n\n");
         break;
      case 3:
         printf("\n! This program requires remap communication \n\n");
         break;
      case 4:
         printf("\n! This program requires both shift and remap \n\n");
         break;
      default:
         printf("No such a case \n");
         return;
   }

   printf("      PROGRAM MAIN \n");
   printf("      REAL X(%d:%d,%d:%d), Y(%d:%d,%d:%d) \n",
                 lx1,ux1,lx2,ux2,ly1,uy1,ly2,uy2); 
   printf("!HPF$ PROCESSORS P(%d) ", p);
   if (requirement < 3) { 
      printf("!HPF$ TEMPLATE T(%d:%d,%d:%d) \n", ltx1,utx1,ltx2,utx2);
      printf("!HPF$ DISTRIBUTE T(%s,%s) ONTO P \n",dc[0],dc[1]);
      if (bx1 >= 0 && bx2 >= 0)
         printf("!HPF$ ALIGN X(i,j) WITH T(%d*i+%d, %d*j+%d) ",ax1,bx1,ax2,bx2);
      else if (bx1 >= 0 && bx2 < 0)
         printf("!HPF$ ALIGN X(i,j) WITH T(%d*i+%d, %d*j%d) ",ax1,bx1,ax2,bx2);
      else if (bx1 < 0 && bx2 >= 0)
         printf("!HPF$ ALIGN X(i,j) WITH T(%d*i%d, %d*j+%d) ",ax1,bx1,ax2,bx2);
      else 
         printf("!HPF$ ALIGN X(i,j) WITH T(%d*i%d, %d*j%d) ",ax1,bx1,ax2,bx2);
      if (by1 >= 0 && by2 >= 0)
         printf("!HPF$ ALIGN Y(i,j) WITH T(%d*i+%d, %d*j+%d) \n",ay1,by1,ay2,by2);
      else if (by1 >= 0 && by2 < 0)
         printf("!HPF$ ALIGN Y(i,j) WITH T(%d*i+%d, %d*j%d) \n",ay1,by1,ay2,by2);
      else if (by1 < 0 && by2 >= 0)
         printf("!HPF$ ALIGN Y(i,j) WITH T(%d*i%d, %d*j+%d) \n",ay1,by1,ay2,by2);
      else 
         printf("!HPF$ ALIGN Y(i,j) WITH T(%d*i%d, %d*j%d) \n",ay1,by1,ay2,by2);
   }
   else {
      printf("!HPF$ TEMPLATE TX(%d:%d,%d:%d),TY(%d:%d,%d:%d) \n",
              ltx1,utx1,ltx2,utx2, lty1,uty1,lty2,uty2); 
      printf("!HPF$ DISTRIBUTE TX(%s,%s) ONTO P \n", dc[0],dc[1]); 
      printf("!HPF$ DISTRIBUTE TY(%s,%s) ONTO P \n",dc[2],dc[3]); 
      if (bx1 >= 0 && bx2 >= 0)
         printf("!HPF$ ALIGN X(i,j) WITH TX(%d*i+%d, %d*j+%d) ",ax1,bx1,ax2,bx2);
      else if (bx1 >= 0 && bx2 < 0)
         printf("!HPF$ ALIGN X(i,j) WITH TX(%d*i+%d, %d*j%d) ",ax1,bx1,ax2,bx2);
      else if (bx1 < 0 && bx2 >= 0)
         printf("!HPF$ ALIGN X(i,j) WITH TX(%d*i%d, %d*j+%d) ",ax1,bx1,ax2,bx2);
      else 
         printf("!HPF$ ALIGN X(i,j) WITH TX(%d*i%d, %d*j%d) ",ax1,bx1,ax2,bx2);
      if (by1 >= 0 && by2 >= 0)
         printf("!HPF$ ALIGN Y(i,j) WITH TY(%d*i+%d, %d*j+%d) \n",ay1,by1,ay2,by2);
      else if (by1 >= 0 && by2 < 0)
         printf("!HPF$ ALIGN Y(i,j) WITH TY(%d*i+%d, %d*j%d) \n",ay1,by1,ay2,by2);
      else if (by1 < 0 && by2 >= 0)
         printf("!HPF$ ALIGN Y(i,j) WITH TY(%d*i%d, %d*j+%d) \n",ay1,by1,ay2,by2);
      else 
         printf("!HPF$ ALIGN Y(i,j) WITH TY(%d*i%d, %d*j%d) \n",ay1,by1,ay2,by2);
   };
   printf("      FORALL (i= %d: %d,j= %d: %d) X(i,j) = 0 \n",lx1,ux1,lx2,ux2);
   printf("      FORALL (i= %d: %d,j= %d: %d) Y(i,j) = i + j \n",
      ly1,uy1,ly2,uy2);
   printf("      FORALL (i=%d:%d:%d,j=%d:%d:%d) X(i,j) = Y(i+1,j) + Y(i,j+1) \n",
      l1,u1,s1,l2,u2,s2);
   printf("      FORALL (i=%d:%d:2,j=%d:%d:2,X(i,j)/=0) X(i,j) = 1 \n",
      lx1,ux1,lx2,ux2);

   if (lxs1 == uxs1) 
      printf("      CALL FOO(X(%d,%d:%d:%d)) \n",lxs1,lxs2,uxs2,sxs2);
   else
      printf("      CALL FOO(X(%d:%d:%d,%d)) \n",lxs1,uxs1,sxs1,lxs2);

   printf("      PRINT *, (X(i,1),i=%d,%d,2) \n      END \n",lx1,ux1);

   printf("      SUBROUTINE FOO(X) \n");
   printf("      REAL X(%d:%d) \n", slx,sux);
   printf("!HPF$ INHERIT X \n");
   printf("      REAL Y(%d:%d) \n",sly,suy);
   printf("!HPF$ PROCESSORS P(%d) \n",p);
   printf("!HPF$ TEMPLATE T(%d:%d) \n",sly,suy);
   printf("!HPF$ ALIGN Y(i) WITH T(i) \n");
   printf("!HPF$ DISTRIBUTE T(%s) ONTO P \n",dc[4]);

   printf("      FORALL (i=%d:%d) Y(i) = 2 \n",sly,suy);
   printf("      FORALL (i=%d:%d) X(i) = Y(i) + 1  \n",sl,su);
   printf("      END \n");
   return;
};

