
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "generator.h"

extern void binding_2(int,int,int,int,int,int,int,int,int,int,int,
                      int,int,int,int,int,int,int,int,int,int,int,int,
                      int,int,int,int,int,int,int,int,int,int,int,int);

extern void check_2(int,int,int,int,int,int,int,int,int,int,int,
                    int,int,int,int,int,int,int,int,int,int,int,int,
                    int,int,int,int,int,int,int,int,int,int,int,int);

void main(int argc, char *argv[]) {

   int p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2;
   int requirement,t,map,tx,ty,r,m,i;
   int lxs1,uxs1,sxs1,lys1,uys1,sys1,lxs2,uxs2,sxs2,lys2,uys2,sys2;

   unsigned int seed;

   if (argc > 1) {
      requirement = atoi(argv[1]);
/*     seed = atoi(argv[2]); */
   }
   else {
      printf("Please include requirement code in command line: \n");
      printf("1 -- no communication, 2 -- shift only \n");
      printf("3 -- remap only,       4 -- both shift and remap \n");
      return;
   }

   srand((unsigned int) time(NULL));

   t = rand() % 3;
   /*  p = pow(2,t+1); the number of processors: 2, 4, 8 */
   p = 2;
   while (t != 0) { p = p*2; t--;};

   l = rand()%10; if(rand()%2) l=-l;
   u = rand()%10; if(rand()%2) u=-u;
   u = l + LOAD + u;
   s = rand() % MAX_STRIDE + 1;

   switch (requirement) {
     case 1: /* no communication */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           a1 = a2 = rand()%MAX_STRIDE + 1;
           b1 = b2 = rand()%10; if(rand()%2) b1=b2=-b1;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+b1 - rand()%MAX_DISPLACEMENT;
           
           m = (-ay*ly + (a1*l+b1)*ay+1)/(ay*a1) - l + 1;

           bx = rand()%10; if(rand()%2) bx = -bx;
           ltx = bx+1 -(max(-lx+1,m)+rand()%10)*ax; 

           /* map = ceiling((ax*l+bx)*ay*a1/ax); 
              where ax*l+bx > 0 is the positin of the first related element 
              of X in its template */
           map = (ax*l+bx-ltx+1)*ay*a1/ax;

           by = rand()%10; if(rand()%2) by = -by;
           lty = (a1*l+b1)*ay+by+1 - map;
           /* the above set up cannonical eq-ele condition */

           ux = u + rand()%100;
           uy = a1*u+b1 + rand()%100;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           m = max(tx/ax,ty/(ay*a1)) + 1;

           tx = m*ax;  ty = m*(ay*a1);
           utx = tx + ltx - 1; 
           uty = ty + lty - 1;

           while (tx%p || ty%p) { /* make sure p divides both tx and ty */
              tx = tx*2; utx = tx + ltx -1;
              ty = ty*2; uty = ty + lty -1;
           }
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = a2 = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
           /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */
           b1 = b2 = rand()%MAX_OFFSET; if (rand()%2) b1 = b2 = -b1;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+b1 - rand()%MAX_DISPLACEMENT;

           t = ((ax*l-ax*lx)/p + 1)*p - ax*l;   /* bx-ltx */

           bx = rand()%MAX_OFFSET; if(rand()%2) bx = -bx;
           ltx = bx - t; 

           t = ((ay*(a1*l+b1)-ay*ly)/p + 1)*p - ay*(a1*l+b1);   /* by-lty */

           by = rand()%MAX_OFFSET; if(rand()%2) by = -by;
           lty = by - t; 

           ux = u + rand()%100;
           uy = a1*u+b1 + rand()%100;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx + rand()%10;
           uty = ay*uy+by + rand()%10;

        }
        break;
     case 2: /* shift only */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           a1 = a2 = rand()%MAX_STRIDE + 1;
           b1 = rand()%10; if(rand()%2) b1=-b1;
           b2 = rand()%10; if(rand()%2) b2=-b2;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;
           
           bx = rand()%10; if(rand()%2) bx = -bx;
           ltx = lx*ax + bx - rand()%MAX_DISPLACEMENT;

           by = rand()%10; if(rand()%2) by = -by;
           lty = ly*ay + by - rand()%MAX_DISPLACEMENT;

           ux = u + rand()%100;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           m = max(tx/ax,ty/(ay*a1)) + 1;

           tx = m*ax;  ty = m*(ay*a1);
           utx = tx + ltx - 1; 
           uty = ty + lty - 1;

           while (tx%p || ty%p) { /* make sure p divides both tx and ty */
              tx = tx*2; utx = tx + ltx -1;
              ty = ty*2; uty = ty + lty -1;
           }
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = a2 = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
          /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */
           b1 = rand()%MAX_OFFSET; if (rand()%2) b1 = -b1;
           b2 = rand()%MAX_OFFSET; if (rand()%2) b2 = -b2;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;

           bx = rand()%MAX_OFFSET; if(rand()%2) bx = -bx;
           ltx = lx*ax + bx - rand()%MAX_DISPLACEMENT; 

           by = rand()%MAX_OFFSET; if(rand()%2) by = -by;
           lty = ly*ay + by - rand()%MAX_DISPLACEMENT;

           ux = u + rand()%100;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx + rand()%MAX_DISPLACEMENT;
           uty = ay*uy+by + rand()%MAX_DISPLACEMENT;

        }
        break;
     case 3: /* remap only */
        d1 = rand()%2 + 1;
        d2 = rand()%2 + 1;

        lx = l - rand()%MAX_DISPLACEMENT; 
        ux = u + rand()%100;

        ly = rand()%10; if (rand()%2) ly = -ly;
        a1 = rand()%4 + 1;
        a2 = rand()%4 + 1;
        b1 = ly - a1*l + rand()%10; 
        b2 = ly - a2*l + rand()%10; 
        uy = max(a1*u+b1,a2*u+b2) + rand()%100;
        /* the above set up within-array-bound condition */

        ltx = rand()%10; if (rand()%2) ltx = -ltx;
        ax = rand()%MAX_STRIDE + 1;
        bx = ltx - ax*lx + rand()%10;
        utx = ax*ux+bx + rand()%100;

        lty = rand()%10; if (rand()%2) lty = -lty;
        ay = rand()%MAX_STRIDE + 1;
        by = lty - ay*ly + rand()%10;
        uty = ay*uy+by + rand()%100;
        /* the above set up within-template-bound condition */
        break;
     case 4: /* first term shift, second term remap */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           a1 = a2 = rand()%MAX_STRIDE + 1;
           b1 = rand()%10; if(rand()%2) b1=-b1;
           b2 = rand()%10; if(rand()%2) b2=-b2;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;
           
           bx = rand()%10; if(rand()%2) bx = -bx;
           ltx = lx*ax + bx - rand()%MAX_DISPLACEMENT;

           by = rand()%10; if(rand()%2) by = -by;
           lty = ly*ay + by - rand()%MAX_DISPLACEMENT;

           ux = u + rand()%100;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           m = max(tx/ax,ty/(ay*a1)) + 1;

           tx = m*ax;  ty = m*(ay*a1);
           utx = tx + ltx - 1; 
           uty = ty + lty - 1;

           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = a2 = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
          /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */
           b1 = rand()%MAX_OFFSET; if (rand()%2) b1 = -b1;
           b2 = rand()%MAX_OFFSET; if (rand()%2) b2 = -b2;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;

           bx = rand()%MAX_OFFSET; if(rand()%2) bx = -bx;
           ltx = lx*ax + bx - rand()%MAX_DISPLACEMENT; 

           by = rand()%MAX_OFFSET; if(rand()%2) by = -by;
           lty = ly*ay + by - rand()%MAX_DISPLACEMENT;

           ux = u + rand()%100;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx + rand()%MAX_DISPLACEMENT;
           uty = ay*uy+by + rand()%MAX_DISPLACEMENT;

        }
        break;

        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%4 + 1;
           ay = rand()%4 + 1;
           a1 = rand()%4 + 1;
           a2 = rand()%4 + 1;
           /* the above set up ratio for shift-homomorphism condition */

           lx = rand()%10; if (rand()%2) lx = -lx;
           if (ax*lx < 0)
              bx = -(ax*lx) + rand()%10;
           else
              if (rand()%2)
                 bx = rand()%10;
              else
                 bx = -(ax*lx) + rand()%(ax*lx);
           /* we make sure ax*lx+bx > 0 */
           ly = rand()%10; if (rand()%2) ly = -ly;
           if (ay*ly < 0)
              by = -(ay*ly) + rand()%10;
           else
              if (rand()%2)
                 by = rand()%10;
              else
                 by = -(ay*ly) + rand()%(ay*ly);
           /* we make sure ay*ly+by > 0 */

           l = lx + rand()%10;

           b1 = ly - a1*l + rand()%10; 
           b2 = ly - a1*l + rand()%10; 

           ux = lx + rand() % 1000;
           u = ux -rand()%100;
           uy = max(a1*u+b1,a2*u+b2) + rand()%100;
           /* the above set up within-array-bound condition */

           ltx = 1; utx = ax*ux+bx; tx = utx-ltx+1;
           lty = 1; uty = ay*uy+by; ty = uty-lty+1;

           if (ax/(ay*a1) > tx/ty) {
              t = (ty%(ay*a1))?(ty/(ay*a1)+1)*ay*a1:ty;
              uty = uty + (t-ty); ty = uty-lty+1;
              t = ty*ax/(ay*a1);
              utx = utx + (t-tx);
           }
           else {
              t = (tx%ax)?(tx/ax+1)*ax:tx;
              utx = utx + (t-tx); tx = utx-ltx+1;
              t = tx*ay*a1/ax;
              uty = uty + (t-ty);
           }  
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = rand()%4 + 1;
           a2 = rand()%4 + 1;
           ay = rand()%4 + 1;
           ax = ay*a1;
           /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */

           lx = rand()%10; if (rand()%2) lx = -lx;
           if (ax*lx < 0)
              bx = -(ax*lx) + rand()%10;
           else
              if (rand()%2)
                 bx = rand()%10;
              else
                 bx = -(ax*lx) + rand()%(ax*lx);
           /* we make sure ax*lx+bx > 0 */
           ly = rand()%10; if (rand()%2) ly = -ly;
           if (ay*ly < 0)
              by = -(ay*ly) + rand()%10;
           else
              if (rand()%2)
                 by = rand()%10;
              else
                 by = -(ay*ly) + rand()%(ay*ly);
           /* we make sure ay*ly+by > 0 */

           l = lx + rand()%10;

           b1 = ly - a1*l + rand()%10; 
           b2 = ly - a1*l + rand()%10; 
          
           ux = lx + rand() % 1000;
           u = ux - rand()%100;
           uy = a1*u+max(b1,b2) + rand()%100;

           /* the above set up within-array-bound condition */

           ltx = 1; utx = ax*ux+bx; tx = utx-ltx+1;
           lty = 1; uty = ay*uy+by; ty = uty-lty+1;
        }
        break;
     default:
        printf("No such a case \n");
  }

   uxs2 = ux+1;
   while (uxs2 > ux) {
   lxs1 = lx + rand()%5; 
   sxs1 = rand()%3+1; 
   uxs1 = lxs1 + ((ux-lx)/sxs1 -(rand()%5+lxs1-lx))*sxs1; 
   lxs2 = lx + rand()%5; 
   sxs2 = rand()%3+1;
   uxs2 = lxs2 + (uxs1-lxs1)*sxs2/sxs1;
   };

   uys2 = uy+1;
   while (uys2 > uy) {
   lys1 = ly + rand()%5; 
   sys1 = rand()%3+1; 
   uys1 = lys1 + ((uy-ly)/sys1 -(rand()%5+lys1-ly))*sys1; 
   lys2 = ly + rand()%5; 
   sys2 = rand()%3+1;
   uys2 = lys2 + (uys1-lys1)*sys2/sys1;
   };

   check_2(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
           ltx,utx,lty,uty,bx,by,b1,b2,
           lxs1,uxs1, sxs1, lys1, uys1, sys1,
           lxs2,uxs2, sxs2, lys2, uys2, sys2);

   binding_2(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
           ltx,utx,lty,uty,bx,by,b1,b2,
           lxs1,uxs1, sxs1, lys1, uys1, sys1,
           lxs2,uxs2, sxs2, lys2, uys2, sys2);
   printf("!          p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2, \n");
   printf("!          ltx,utx,lty,uty,bx,by,b1,b2, \n");
   printf("!          lxs1,uxs1, sxs1, lys1, uys1, sys1, \n");
   printf("!          lxs2,uxs2, sxs2, lys2, uys2, sys2 \n");
   printf("!          %d %d %d %d %d %d %d %d %d %d %d %d %d %d \n",
           p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2);
   printf("!          %d %d %d %d %d %d %d %d  \n",
           ltx,utx,lty,uty,bx,by,b1,b2);
   printf("!          %d %d %d %d %d %d \n",
           lxs1,uxs1, sxs1, lys1, uys1, sys1);
   printf("!          %d %d %d %d %d %d \n",
           lxs2,uxs2, sxs2, lys2, uys2, sys2);
}

