#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include        <stdio.h>
#include        <malloc.h>

#include        "tof77.h"

#include "compilerApi.h"

char * mixstring="pcrc";

Flag in_main_program = off;
Flag in_procedure = off;
Flag in_function=off;

int do_level = 0;

SgFile * global_file;

/* This function is used to cut the surfix, so there is a record as different pass performed, zgs */

char *newOutputFileName(char *inputFileName)
{
  char  *out;
  int   nameLength = strlen(inputFileName);
  
  out=(char *)malloc((unsigned)(nameLength+10));

  while (inputFileName[nameLength-1]!='.') {
    nameLength --;
  }

  for ( int i = 0; i<nameLength; i++) {
    out[i]=inputFileName[i];
  }

  out[nameLength-1]='\0';

  out=strcat(out,"_f77.dep");

  return(out);
}

char    *get_file_out(char *file_in)
{       char    *file_out;
        int     i=0;


        file_out=(char *)malloc((unsigned)(strlen(file_in)+5));
        while (file_in[i]!='.') 
        {       file_out[i]=file_in[i];
                i++;
        }
        file_out[i]='\0';
        file_out=strcat(file_out,"_r.dep");
        return(file_out);

}

//add attribute statement in the first analyse ---------analyse1()
void add_attr_stmt(SgStatement * s)
 {  SgExpression * expr=NULL;
    SgExpression *var_list = s->expr(0);
    SgExpression *attr_list = s->expr(2);

    if(s->expr(2)!=NULL)
      {
         expr=s->expr(2);
         while(expr!=NULL)
           { 
            switch(expr->lhs()->variant())
              {
               case DIMENSION_OP:
                   {  SgExpression * exprlist=NULL;
                      SgExpression * ddot=attr_list->lhs()->lhs()->copyPtr();
                       
		      for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
                      {
			SgExpression * var= exp->lhs()->copyPtr();
                        if(var->variant()==VAR_REF)
                           { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->symbol());
                             exp->setLhs(exprlist);
                            }
                         if(var->variant()==ASSGN_OP)
                             if(var->lhs()->variant()==VAR_REF)
                              { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->symbol());
                                exp->lhs()->setLhs(exprlist);
                              } 
                         if(var->variant()==STAR_LIST)
                            {  if(var->lhs()->variant()==VAR_REF)
                                {  exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->symbol());
                                   exp->lhs()->setLhs(exprlist);
                                 } 
                              if(var->lhs()->variant()==ASSGN_OP)
                                 if(var->lhs()->lhs()->variant()==VAR_REF)
                                  { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->lhs()->symbol());
                                    exp->lhs()->lhs()->setLhs(exprlist);
                                  } 
                             }   
                      }

                      break;
                   }
                case PARAMETER_OP:
		      {	SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();

                          if(var->variant()==ASSGN_OP)
                            { var=var->lhs()->copyPtr();
                                 //clear assign_op
	       	              exp->setLhs(exp->lhs()->lhs());
                            } 
                           if(var->variant()==STAR_LIST)
                            { var=var->lhs()->lhs()->copyPtr();
                                 //clear assign_op
                              exp->lhs()->setLhs(exp->lhs()->lhs()->lhs());
                            }
                           
                          SgExpression *const_ref=new SgExpression(CONST_REF,NULL,NULL,var->symbol());
			  exprlist= new SgExpression(EXPR_LIST,const_ref,exprlist,NULL);
			}
                        SgStatement  * declStmt=new SgStatement(PARAM_DECL,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtAfter(*declStmt,*s->controlParent());
                        break;
                      }

                 case SAVE_OP: 
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(SAVE_DECL,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }

                 
                 case EXTERNAL_OP:
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(EXTERN_STAT,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }
                 case INTRINSIC_OP:
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(INTRIN_STAT,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }
                 case PUBLIC_OP:
                 case PRIVATE_OP:
                 case ALLOCATABLE_OP:
                 case IN_OP:
                 case OUT_OP:
                 case INOUT_OP:
                         break;

                 case POINTER_OP:
                 case OPTIONAL_OP:
                 case TARGET_OP:
                 case INHERIT_OP:
                 case DYNAMIC_OP:
                     //do nothing
                      break;   
              }
             expr=expr->rhs();
          }
     }        
 }
 
//the first analyse   
void analyse1(SgStatement * s)
{
  switch(s->variant()) {

  case GLOBAL:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];


      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);
      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;

      break;
    };

  case PROG_HEDR:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i; 

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      // do nothing?;
      in_main_program=on;

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;

      in_main_program=off;
	
      break;

    };

  case IMPL_DECL:
     {
       if(s->expr(0)==NULL)
          s->deleteStmt( );
       break;
    }

  case PROC_HEDR:
    {
      SgProcHedrStmt * prochedr = (SgProcHedrStmt *)s;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_procedure=on;
/*
      for (i=0; i<prochedr->numberOfParameters(); i++) {
	prochedr->parameter(i)->addAttribute(DUMP_Def, NULL, 0);
	prochedr->addAttribute(DUMP_Def, NULL, 0);
      }
*/

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      in_procedure = off;

      break;
    };

  case FUNC_HEDR:
    {
      SgFuncHedrStmt * prochedr = (SgFuncHedrStmt *)s;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_function=on;
      
/*
      for (i=0; i<prochedr->numberOfParameters(); i++) {
	prochedr->parameter(i)->addAttribute(DUMP_Def, NULL, 0);
	prochedr->addAttribute(DUMP_Def, NULL, 0);
      }
*/

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      in_function = off;

      break;
    }

  case COMBINED_DIRECTIVE_DECL:
    break;

  case PROCESSORS_STMT:
//    analyse_processor(s);
    break;

  case TEMPLATE_STMT:
//    analyse_template(s);
    break;

  case ALIGN_DECL:
    break;
    
  case DISTRIBUTE_DECL:
//    analyse_distribute(s);
    break;

  case INHERIT_DECL:
//    analyse_inherit(s);
    break;

  case VAR_DECL:
       { 
           SgExpression * exprlist=NULL;
           
           add_attr_stmt(s); 
               //motify  s->expr(2)
           for(SgExpression *exp=s->expr(2); exp; exp=exp->rhs())
             {  
                switch(exp->lhs()->variant())
                { 
                 case POINTER_OP:
                 case OPTIONAL_OP:
                 case TARGET_OP:
                 case INHERIT_OP:
                 case DYNAMIC_OP:
                     { SgExpression * var=exp->lhs()->copyPtr();
                       exprlist=new SgExpression(EXPR_LIST,var,exprlist,NULL);
                       break;
                      }
                }
             } //end for
           if(exprlist!=NULL)
            {
               s->expr(2)->setLhs(exprlist->lhs());
               s->expr(2)->setRhs(exprlist->rhs()); 
            }
           else 
              s->thebif->entry.Template.ll_ptr3=NULL;
           break;
    };

  case INTERFACE_STMT:
    //do nothing;
    break;

  case FOR_NODE:
    {
      do_level++;

      int org_numberOfChildren=s->numberOfChildrenList1();

      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      do_level--;

      break;
    }

  case LOGIF_NODE:
  case ELSEIF_NODE:
  case LOGIF_STMT:
  case SWITCH_NODE:
  case CASE_NODE:
    {
      int org_numberOfChildren1=s->numberOfChildrenList1();

      SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];

      int org_numberOfChildren2=s->numberOfChildrenList2();

      SgStatement * * children2 = new SgStatement * [org_numberOfChildren2];

      int i;

      for (i=0; i<org_numberOfChildren1; i++)
	children1[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren1; i++)
	analyse1(children1[i]);
      
      delete [] children1;

      for (i=0; i<org_numberOfChildren2; i++)
	children2[i]=s->childList2(i);			// zheng.gb

      for (i=0; i<org_numberOfChildren2; i++)
	analyse1(children2[i]);
      
      delete [] children2;

      break;

    }

  case ASSGOTO_NODE:
  case STOP_STAT:
    // do nothing;
    break;


  case PROC_STAT:
    //do nothing at presenttime. we will analyse INTERFACE later;
    break;

  case ASSIGN_STAT:
//    analyse_assign(s);
    break;

  case FORALL_STMT:
    {       
/*
      analyse_forall_header(s);
      get_forall_reference(s);

      Forall_header_def * fhdef=(Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
    
      for (int i=0; i<fhdef->getindexnumber(); i++) {
	SgSymbol * index=fhdef->getindexsymb(i);
	index_forall_reference(i, index, s->childList1(0));
      };

      detect_forall_reference(s);
*/
      break;
    }

  case PRINT_STAT:
  case WRITE_STAT:
//    analyse_datatransfer(s);
    break;

  case CONTROL_END:
  case PARAM_DECL:
  case ENDDO_STMT:
  case  FORMAT_STAT:
   // statement need do nothing;
    break;

  default:
//    printf("Not touched statement in analyse on line %d\n", s->lineNumber());
    break;
  };

}

void analyse2(SgStatement * s)
{
  switch(s->variant())
  {
    case GLOBAL:
      {
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i);
         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

        delete [] children;

        break;
      };

   case PROG_HEDR:
      { 
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i); 

         in_main_program=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

         delete [] children;

         in_main_program=off;
  
         break;
       };

   case PROC_HEDR:
      {
        SgProcHedrStmt * prochedr=(SgProcHedrStmt *)s;
        int org_numberOfChildren=s->numberOfChildrenList1();
        SgStatement * * children=new SgStatement * [org_numberOfChildren];

        int i;

        for(i=0;i<org_numberOfChildren;i++)
            children[i]=s->childList1(i);

        in_procedure=on;

        for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);
     
        delete [] children;

        in_procedure=off;

        break;
      };

    case FUNC_HEDR:
      {
         SgFuncHedrStmt * prochedr=(SgFuncHedrStmt *)s;
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
              children[i]=s->childList1(i);

          in_function=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

         delete [] children;

         in_function=off;

         break;
      };  
     
  }
 
}

main(int argc, char * argv[]) 
{
  SgProject * project;
  char *file_in , *file_out;
  int i,j;

	argv++;
        argc--;
        while ((argc > 0) && ((*argv)[0] == '-') )
        {
                i=1;
                while (argv[0][i] != '\0') {
			switch (argv[0][i]) {
			default:
                                printf("warning 422: Unknown option \"%c\" ignored.\n",argv[0][i]);
				exit(1);
			}
			i++;
		}
		argc--;
		argv++;
	}

  argc++; argv--;
  project = new SgProject("test", argc, argv);

  for (i=0; i< project->numberOfFiles(); i++) {

    global_file = &(project->file(i));
    file_in=global_file->filept->filename;

    SgStatement * s;

    s = global_file->firstStatement();
    analyse1(s);

    file_out=newOutputFileName(file_in);
    global_file->saveDepFile(file_out);
    
  };

  return 0;
}






