
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "generator.h"

/***** The template **********************************************
      PROGRAM MAIN
      REAL X(lx1:ux1,lx2:ux2), Y(ly1:uy1,ly2:uy2)
!HPF$ PROCESSORS P(p)
!HPF$ TEMPLATE TX(ltx1:utx1,ltx2:utx2),TY(lty1:uty1,lty2:uty2)
!HPF$ DISTRIBUTE TX(d11,d12) ONTO P
!HPF$ DISTRIBUTE TY(d21,d22) ONTO P
!HPF$ ALIGN X(i,j) WITH TX(ax1*i+bx1,ax2*j+bx2)
!HPF$ ALIGN Y(i,j) WITH TY(ay1*i+by1,ay2*j+by2)

      FORALL (i=lx1:ux1,j=lx2:ux2) X(i,j) = 0
      FORALL (i=ly1:uy1,j=ly2:uy2) Y(i,j) = i + j

      FORALL (i=l1:u1:s1,j=l2:u2:s2) X(i,j) = Y(i+1,j) + Y(i,j+1)
      FORALL (i=lx1:ux1:2,j=lx2:ux2:2,X(i,j)/=0) X(i,j) = 1

      CALL FOO(X(lxs1:uxs1:sxs1,lxs2:uxs2:sxs2))

      PRINT *, (X(i,1),i=lx1,ux1,2)
      END

      SUBROUTINE FOO(X)
      REAL X(slx:sux)
!HPF$ INHERIT X
      REAL Y(sly:suy)
!HPF$ PROCESSORS P(p)
!HPF$ DISTRIBUTE Y(sd) ONTO P

      FORALL (i=sly:suy) Y(i) = 2
      FORALL (i=sl:su) X(i) = Y(i) + 1

      RETURN
      END

****** Involved parameters **************************************

lx1,ux1,lx2,ux2; ly1,uy1,ly2,uy2
p
ltx1,utx1,ltx2,utx2; lty1,uty1,lty2,uty2
d11,d12
d21,d22
ax1,bx1,ax2,bx2
ay1,by1,ay2,by2
l1,u1,s1,l2,u2,s2
lxs1,uxs1,sxs1,lxs2,uxs2,sxs2
slx,sux
sly,suy
sd
sl,su

48 in total
*****************************************************************/

extern void binding_3(int,int,int,int,int,int,int,int,int,int,int,int,
   int,int,int,int,int,int,int*,int,int,int,int,int,int,int,int,
   int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,
   int,int,int);

void distPattern(int d[]) {
  switch (rand()%16) {
     case 0: d[0] = 1; d[1] = 3; d[2] = 1; d[3] = 3;
             break;
     case 1: d[0] = 1; d[1] = 3; d[2] = 2; d[3] = 3;
             break;
     case 2: d[0] = 2; d[1] = 3; d[2] = 1; d[3] = 3;
             break;
     case 3: d[0] = 2; d[1] = 3; d[2] = 2; d[3] = 3;
             break;
     case 4: d[0] = 3; d[1] = 1; d[2] = 3; d[3] = 1;
             break;
     case 5: d[0] = 3; d[1] = 1; d[2] = 3; d[3] = 2;
             break;
     case 6: d[0] = 3; d[1] = 2; d[2] = 3; d[3] = 1;
             break;
     case 7: d[0] = 3; d[1] = 2; d[2] = 3; d[3] = 2;
             break;
     case 8: d[0] = 1; d[1] = 3; d[2] = 3; d[3] = 1;
             break;
     case 9: d[0] = 1; d[1] = 3; d[2] = 3; d[3] = 2;
             break;
     case 10: d[0] = 2; d[1] = 3; d[2] = 3; d[3] = 1;
             break;
     case 11: d[0] = 2; d[1] = 3; d[2] = 3; d[3] = 2;
             break;
     case 12: d[0] = 3; d[1] = 1; d[2] = 1; d[3] = 3;
             break;
     case 13: d[0] = 3; d[1] = 1; d[2] = 2; d[3] = 3;
             break;
     case 14: d[0] = 3; d[1] = 2; d[2] = 1; d[3] = 3;
             break;
     case 15: d[0] = 3; d[1] = 2; d[2] = 2; d[3] = 3;
             break;
     default:
             break;
   }
   d[4] = rand()%2 + 1;
   return;
}

void main(int argc, char *argv[]) {

   int requirement,lx1,ux1,lx2,ux2, ly1,uy1,ly2,uy2;
   int p,ltx1,utx1,ltx2,utx2, lty1,uty1,lty2,uty2;
   int d[5];
   int ax1,bx1,ax2,bx2,ay1,by1,ay2,by2;
   int l1,u1,s1,l2,u2,s2;
   int lxs1,uxs1,sxs1,lxs2,uxs2,sxs2;
   int slx,sux,sly,suy,sl,su,i;  

   int size,t,map,r,m;

   unsigned int seed;

   if (argc > 1) {
      requirement = atoi(argv[1]);
/*     seed = atoi(argv[2]); */
   }
   else {
      printf("Please include requirement code in command line: \n");
      printf("1 -- (1,1), (2,2) communication, 2 -- (1,2),(2,1) \n");
      printf("3 -- remap\n");
      return;
   }

   srand((unsigned int) time(NULL));

   t = rand() % 3;
   p = 2;
   while (t != 0) { p = p*2; t--;};

   l1 = rand()%10; if (rand()%2) l1=-l1;
   u1 = rand()%10; if (rand()%2) u1=-u1;
   u1 = l1 + LOAD + u1;
   l2 = rand()%10; if (rand()%2) l2=-l2;
   u2 = rand()%10; if (rand()%2) u2=-u2;
   u2 = l2 + LOAD + u2;

   switch (requirement) {
      case 1:  /* case of (1,1),(2,2) */
         s1 = s2 = sxs1 = sxs2 = rand() % MAX_STRIDE + 1;
         distPattern(d);
         d[2] = d[0]; d[3] = d[1];

         ay1 = ax1 = rand()%MAX_STRIDE + 1;
         by1 = bx1 = rand()%MAX_OFFSET; if(rand()%2) by1 = bx1 = -bx1;
         lty1 = ltx1 = ax1*l1+bx1 - ax1*(rand()%10 + 1);
         ly1 = lx1 = l1 - rand()%(l1-(ltx1-bx1)/ax1);
         by1 = by1 - ay1;   /* this is for (1,1) */
  
         ay2 = ax2 = rand()%4 + 2;
         by2 = bx2 = rand()%10; if(rand()%2) by2 = bx2 = -bx2;
         lty2 = ltx2 = ax2*l2+bx2 - ax2*(rand()%10 + 1);
         ly2 = lx2 = l2 - rand()%(l2-(ltx2-bx2)/ax2);

         uy1 = ux1 = u1 + rand()%100 + 1;
         uy2 = ux2 = u2 + rand()%100 + 1;
 
         uty1 = utx1 = ax1*ux1+bx1;
         uty2 = utx2 = ax2*ux2+bx2;

         lxs1 = lx1 + rand()%10;
         lxs2 = lx2 + rand()%10;
         uxs1 = ux1 - rand()%10;
         uxs2 = ux2 - rand()%10;
         if (rand()%2) uxs1 = lxs1; else uxs2 = lxs2;

         if (lxs1 == uxs1)
            size = (uxs2 - lxs2)/sxs2;
         else
            size = (uxs1 - lxs1)/sxs1;

         slx = rand()%10;
         sux = slx + size;
         sly = rand()%10;
         suy = sly + size;
         sl = max(slx,sly);
         su = min(sux,suy);
         break;
      case 2:  /* case of (1,2),(2,1) */
         s1 = s2 = sxs1 = sxs2 = rand() % MAX_STRIDE + 1;
         distPattern(d);
         d[2] = d[0]; d[3] = d[1];

         ay1 = ax1 = rand()%MAX_STRIDE + 1;
         by1 = bx1 = rand()%MAX_OFFSET; if(rand()%2) by1 = bx1 = -bx1;
         lty1 = ltx1 = ax1*l1+bx1 - ax1*(rand()%10 + 1);
         ly1 = lx1 = l1 - rand()%(l1-(ltx1-bx1)/ax1);
         by1 = by1 - ay1;   /* this is for (1,*) */
  
         ay2 = ax2 = rand()%4 + 2;
         by2 = bx2 = rand()%10; if(rand()%2) by2 = bx2 = -bx2;
         lty2 = ltx2 = ax2*l2+bx2 - ax2*(rand()%10 + 1);
         ly2 = lx2 = l2 - rand()%(l2-(ltx2-bx2)/ax2);
         by2 = by2 - ay2;   /* this is for (*,1) */
         uy1 = ux1 = u1 + rand()%100 + 1;
         uy2 = ux2 = u2 + rand()%100 + 1;
 
         uty1 = utx1 = ax1*ux1+bx1;
         uty2 = utx2 = ax2*ux2+bx2;

         lxs1 = lx1 + rand()%10;
         lxs2 = lx2 + rand()%10;
         uxs1 = ux1 - rand()%10;
         uxs2 = ux2 - rand()%10;
         if (rand()%2) uxs1 = lxs1; else uxs2 = lxs2;

         if (lxs1 == uxs1)
            size = (uxs2 - lxs2)/sxs2;
         else
            size = (uxs1 - lxs1)/sxs1;

         slx = rand()%10;
         sux = slx + size;
         sly = rand()%10;
         suy = sly + size;
         sl = max(slx,sly);
         su = min(sux,suy);
         break;
      case 3:
         s1 = s2 = sxs1 = sxs2 = rand() % MAX_STRIDE + 1;

         distPattern(d);
 
         ax1 = rand()%MAX_STRIDE + 1;  
         bx1 = rand()%MAX_OFFSET; if(rand()%2) bx1 = -bx1;
         ltx1 = ax1*l1+bx1 - ax1*(rand()%10 + 1); 
         lx1 = l1 - rand()%(l1-(ltx1-bx1)/ax1);
   
         ax2 = rand()%4 + 2;  
         bx2 = rand()%10; if(rand()%2) bx2 = -bx2;
         ltx2 = ax2*l2+bx2 - ax2*(rand()%10 + 1); 
         lx2 = l2 - rand()%(l2-(ltx2-bx2)/ax2);

         ay1 = rand()%4 + 1;  
         by1 = rand()%10; if(rand()%2) by1 = -by1;
         lty1 = ay1*l1+by1 - ay1*(rand()%10 + 1); 
         ly1 = l1 - rand()%(l1-(lty1-by1)/ay1);
   
         ay2 = rand()%4 + 2;  
         by2 = rand()%10; if(rand()%2) by2 = -by2;
         lty2 = ay2*l2+by2 - ay2*(rand()%10 + 1);
         ly2 = l2 - rand()%(l2-(lty2-by2)/ay2);

         ux1 = u1 + rand()%100;
         ux2 = u2 + rand()%100;
         uy1 = u1+1 + rand()%100;
         uy2 = u2+1 + rand()%100;
  
         utx1 = ax1*ux1+bx1;
         utx2 = ax2*ux2+bx2;
         uty1 = ay1*uy1+by1;
         uty2 = ay2*uy2+by2;

         lxs1 = lx1 + rand()%10;
         lxs2 = lx2 + rand()%10;
         uxs1 = ux1 - rand()%10;
         uxs2 = ux2 - rand()%10;
         if (rand()%2) uxs1 = lxs1; else uxs2 = lxs2;

         if (lxs1 == uxs1) 
            size = (uxs2 - lxs2)/sxs2;
         else
            size = (uxs1 - lxs1)/sxs1;

         slx = rand()%10;
         sux = slx + size;
         sly = rand()%10;
         suy = sly + size;
         sl = max(slx,sly);
         su = min(sux,suy);
         break;
      case 4:
         printf("Not implement yet \n");
         break;
      defaut:
         printf("No such case \n");
   };

   binding_3(requirement,lx1,ux1,lx2,ux2, ly1,uy1,ly2,uy2,p,ltx1,utx1,ltx2,
        utx2,lty1,uty1,lty2,uty2,d,ax1,bx1,ax2,bx2,ay1,
        by1,ay2,by2,l1,u1,s1,l2,u2,s2,lxs1,uxs1,sxs1,lxs2,uxs2,sxs2,slx,
        sux,sly,suy,sl,su);
/*
   printf("!  The parameters in order: \n");
   printf("!  lx1,ux1,lx2,ux2, ly1,uy1,ly2,uy2,p,ltx1,utx1,ltx2,
!  utx2,lty1,uty1,lty2,uty2,d11,d12,d21,d22,sd,ax1,bx1,ax2,bx2,ay1,
!  by1,ay2,by2,l1,u1,s1,l2,u2,s2,lxs1,uxs1,sxs1,lxs2,uxs2,sxs2,slx,
!  sux,sly,suy,sl,su \n");
   printf("!  %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d
!  %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d
!  %d %d %d %d %d %d %d %d \n",
        lx1,ux1,lx2,ux2, ly1,uy1,ly2,uy2,p,ltx1,utx1,ltx2,
        utx2,lty1,uty1,lty2,uty2,d[0],d[1],d[2],d[3],d[4],ax1,bx1,ax2,bx2,ay1,
        by1,ay2,by2,l1,u1,s1,l2,u2,s2,lxs1,uxs1,sxs1,lxs2,uxs2,sxs2,slx,
        sux,sly,suy,sl,su);
*/
}

